---
import { changeLanguage } from "i18next";
import { getCollection, CollectionEntry } from "astro:content";
import MainLayout from "../../layouts/MainLayout.astro";
import PostCard from "../../components/PostCard.astro";
import { slugify, formatBlogPosts } from "../../js/utils";

changeLanguage("en");

export async function getStaticPaths() {
  const allPosts = await getCollection("blog");
  const formattedPosts: CollectionEntry<"blog">[] = formatBlogPosts(allPosts);
  const allAuthors = [
    ...new Set(formattedPosts.map((post) => post.data.author).flat()),
  ];
  return allAuthors.map((author) => {
    const authorPosts = formattedPosts.filter(
      (post) => post.data.author === author
    );
    return {
      params: { author: slugify(author) },
      props: {
        authorName: author,
        posts: authorPosts,
      },
    };
  });
}
interface Props {
  posts: CollectionEntry<"blog">[];
  authorName: string;
}
const { author } = Astro.params;
const { posts, authorName } = Astro.props;
---

<MainLayout title={authorName}>
  <section class="container" aria-label={`Posts by ${authorName}`}>
    <h1 class="h1">Posts by <span>{authorName}</span></h1>
    <div class="post-container">
      {
        posts.map((post) => (
          <PostCard data={post.data} url={post.slug} tagType="h2" />
        ))
      }
    </div>
  </section>
</MainLayout>

